Package net.sf.saxon.option.axiom

## Class AxiomLeafNodeWrapper

- java.lang.Object
- - net.sf.saxon.tree.wrapper.AbstractNodeWrapper
  - - net.sf.saxon.option.axiom.AxiomLeafNodeWrapper

- All Implemented Interfaces:
    `javax.xml.transform.Source`, `javax.xml.transform.SourceLocator`, `GroundedValue`, `Item`, `NodeInfo`, `Sequence`, `Location`, `SiblingCountingNode`, `VirtualNode`, `org.xml.sax.Locator`

      public class AxiomLeafNodeWrapper
      extends AbstractNodeWrapper
      implements SiblingCountingNode

  A node in the XDM tree. This is the implementation of the NodeInfo interface used as a wrapper for Axiom comment, text, and processing instruction nodes.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected int` | `index` |
    `protected org.apache.axiom.om.OMNode` | `node` |
    `protected short` | `nodeKind` |

    - ### Fields inherited from class net.sf.saxon.tree.wrapper.AbstractNodeWrapper

      `treeInfo`

    - ### Fields inherited from interface net.sf.saxon.om.NodeInfo

      `IS_DTD_TYPE, IS_NILLED`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `protected` | `AxiomLeafNodeWrapper​(org.apache.axiom.om.OMNode node, AxiomDocument docWrapper, AxiomParentNodeWrapper parent, int index)` | This constructor is protected: nodes should be created using the wrap factory method on the DocumentWrapper class

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `int` | `compareOrder​(NodeInfo other)` | Determine the relative position of this node and another node, in document order.
    `void` | `generateId​(FastStringBuffer buffer)` | Get a character string that uniquely identifies this node.
    `NamespaceBinding[]` | `getDeclaredNamespaces​(NamespaceBinding[] buffer)` | Get all namespace undeclarations and undeclarations defined on this element.
    `java.lang.String` | `getDisplayName()` | Get the display name of this node.
    `java.lang.String` | `getLocalPart()` | Get the local part of the name of this node.
    `int` | `getNodeKind()` | Return the type of node.
    `AxiomParentNodeWrapper` | `getParent()` | Get the NodeInfo object representing the parent of this node
    `java.lang.String` | `getPrefix()` | Get the prefix of the name of the node.
    `NodeInfo` | `getRoot()` | Get the root node of the tree containing this node
    `SchemaType` | `getSchemaType()` | Get the type annotation of this node, if any.
    `int` | `getSiblingPosition()` | Get the index position of this node among its siblings (starting from 0)
    `java.lang.CharSequence` | `getStringValueCS()` | Get the value of the item as a CharSequence.
    `org.apache.axiom.om.OMNode` | `getUnderlyingNode()` | Get the underlying XOM node, to implement the VirtualNode interface
    `java.lang.String` | `getURI()` | Get the URI part of the name of this node.
    `boolean` | `hasChildNodes()` | Determine whether the node has any children.
    `protected AxisIterator` | `iterateAttributes​(java.util.function.Predicate<? super NodeInfo> nodeTest)` | Return an iterator over the attributes of this element node.
    `protected AxisIterator` | `iterateChildren​(java.util.function.Predicate<? super NodeInfo> nodeTest)` | Return an iterator over the children of this node.
    `protected AxisIterator` | `iterateDescendants​(java.util.function.Predicate<? super NodeInfo> nodeTest, boolean includeSelf)` | Return an iterator over the descendants of this node.
    `protected AxisIterator` | `iterateSiblings​(java.util.function.Predicate<? super NodeInfo> nodeTest, boolean forwards)` | Return an iterator over the siblings of this node.

    - ### Methods inherited from class net.sf.saxon.tree.wrapper.AbstractNodeWrapper

      `atomize, equals, getAllNamespaces, getAttributeValue, getBaseURI, getColumnNumber, getFingerprint, getLineNumber, getNamePool, getRealNode, getStringValue, getSystemId, getTreeInfo, hasFingerprint, hashCode, iterateAxis, iterateAxis, saveLocation, setSystemId`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.om.GroundedValue

      `asIterable, concatenate, containsNode, effectiveBooleanValue, materialize`

    - ### Methods inherited from interface net.sf.saxon.om.Item

      `getLength, head, itemAt, iterate, reduce, subsequence`

    - ### Methods inherited from interface net.sf.saxon.s9api.Location

      `saveLocation`

    - ### Methods inherited from interface net.sf.saxon.om.NodeInfo

      `atomize, attributes, children, children, copy, equals, getAllNamespaces, getAttributeValue, getBaseURI, getColumnNumber, getConfiguration, getFingerprint, getGenre, getLineNumber, getPublicId, getStringValue, getSystemId, getTreeInfo, hasFingerprint, hashCode, isId, isIdref, isNilled, isSameNodeInfo, isStreamed, iterateAxis, iterateAxis, toShortString`

    - ### Methods inherited from interface net.sf.saxon.om.Sequence

      `makeRepeatable`

    - ### Methods inherited from interface javax.xml.transform.Source

      `isEmpty, setSystemId`

- - ### Field Detail

    - #### node

          protected org.apache.axiom.om.OMNode node

    - #### nodeKind

          protected short nodeKind

    - #### index

          protected int index

  - ### Constructor Detail

    - #### AxiomLeafNodeWrapper

          protected AxiomLeafNodeWrapper​(org.apache.axiom.om.OMNode node,
                                         AxiomDocument docWrapper,
                                         AxiomParentNodeWrapper parent,
                                         int index)

      This constructor is protected: nodes should be created using the wrap factory method on the DocumentWrapper class
      Parameters:
        `node` - The Axiom node to be wrapped
        `docWrapper` - The wrapper of the containing document node - must not be null
        `parent` - The NodeWrapper that wraps the parent of this node; null means unknwon
        `index` - Position of this node among its siblings

  - ### Method Detail

    - #### getUnderlyingNode

          public org.apache.axiom.om.OMNode getUnderlyingNode()

      Get the underlying XOM node, to implement the VirtualNode interface
      Specified by:
        `getUnderlyingNode` in interface `VirtualNode`
      Returns:
        The underlying node.

    - #### getNodeKind

          public int getNodeKind()

      Return the type of node.
      Specified by:
        `getNodeKind` in interface `NodeInfo`
      Returns:
        one of the values Node.ELEMENT, Node.TEXT, Node.ATTRIBUTE, etc.
      See Also:
        `Type`

    - #### getSchemaType

          public SchemaType getSchemaType()

      Get the type annotation of this node, if any. The type annotation is represented as SchemaType object.

      Types derived from a DTD are not reflected in the result of this method.

      Specified by:
        `getSchemaType` in interface `NodeInfo`
      Returns:
        For element and attribute nodes: the type annotation derived from schema validation (defaulting to xs:untyped and xs:untypedAtomic in the absence of schema validation). For comments, text nodes, processing instructions, and namespaces: null. For document nodes, either xs:untyped if the document has not been validated, or xs:anyType if it has.
      Since:
        9.4

    - #### compareOrder

          public int compareOrder​(NodeInfo other)

      Determine the relative position of this node and another node, in document order. The other node will always be in the same document.
      Specified by:
        `compareOrder` in interface `NodeInfo`
      Parameters:
        `other` - The other node, whose position is to be compared with this node
      Returns:
        -1 if this node precedes the other node, +1 if it follows the other node, or 0 if they are the same node. (In this case, isSameNode() will always return true, and the two nodes will produce the same result for generateId())

    - #### getStringValueCS

          public java.lang.CharSequence getStringValueCS()

      Get the value of the item as a CharSequence. This is in some cases more efficient than the version of the method that returns a String.
      Specified by:
        `getStringValueCS` in interface `GroundedValue`
      Specified by:
        `getStringValueCS` in interface `Item`
      Returns:
        the string value of the item
      See Also:
        `Item.getStringValue()`

    - #### getLocalPart

          public java.lang.String getLocalPart()

      Get the local part of the name of this node. This is the name after the ":" if any.
      Specified by:
        `getLocalPart` in interface `NodeInfo`
      Returns:
        the local part of the name. For an unnamed node, returns "".

    - #### getPrefix

          public java.lang.String getPrefix()

      Get the prefix of the name of the node. This is defined only for elements and attributes. If the node has no prefix, or for other kinds of node, return a zero-length string.
      Specified by:
        `getPrefix` in interface `NodeInfo`
      Returns:
        The prefix of the name of the node.

    - #### getURI

          public java.lang.String getURI()

      Get the URI part of the name of this node. This is the URI corresponding to the prefix, or the URI of the default namespace if appropriate.
      Specified by:
        `getURI` in interface `NodeInfo`
      Returns:
        The URI of the namespace of this node. For an unnamed node, or for a node with an empty prefix, return an empty string.

    - #### getDisplayName

          public java.lang.String getDisplayName()

      Get the display name of this node. For elements and attributes this is [prefix:]localname. For unnamed nodes, it is an empty string.
      Specified by:
        `getDisplayName` in interface `NodeInfo`
      Overrides:
        `getDisplayName` in class `AbstractNodeWrapper`
      Returns:
        The display name of this node. For a node with no name, return an empty string.

    - #### getParent

          public AxiomParentNodeWrapper getParent()

      Get the NodeInfo object representing the parent of this node
      Specified by:
        `getParent` in interface `NodeInfo`
      Returns:
        the parent of this node; null if this node has no parent

    - #### getSiblingPosition

          public int getSiblingPosition()

      Get the index position of this node among its siblings (starting from 0)
      Specified by:
        `getSiblingPosition` in interface `SiblingCountingNode`
      Returns:
        0 for the first child, 1 for the second child, etc.

    - #### iterateAttributes

          protected AxisIterator iterateAttributes​(java.util.function.Predicate<? super NodeInfo> nodeTest)

      Description copied from class: `AbstractNodeWrapper`
      Return an iterator over the attributes of this element node. This method is only called after checking that the node is an element.
      Specified by:
        `iterateAttributes` in class `AbstractNodeWrapper`
      Parameters:
        `nodeTest` - a test that the returned attributes must satisfy
      Returns:
        an iterator over the attribute nodes. The order of the result, although arbitrary, must be consistent with document order.

    - #### iterateChildren

          protected AxisIterator iterateChildren​(java.util.function.Predicate<? super NodeInfo> nodeTest)

      Description copied from class: `AbstractNodeWrapper`
      Return an iterator over the children of this node. This method is only called after checking that the node is an element or document.
      Specified by:
        `iterateChildren` in class `AbstractNodeWrapper`
      Parameters:
        `nodeTest` - a test that the returned attributes must satisfy
      Returns:
        an iterator over the child nodes, in document order.

    - #### iterateSiblings

          protected AxisIterator iterateSiblings​(java.util.function.Predicate<? super NodeInfo> nodeTest,
                                                 boolean forwards)

      Description copied from class: `AbstractNodeWrapper`
      Return an iterator over the siblings of this node. This method is only called after checking that the node is an element, text, comment, or PI node.
      Specified by:
        `iterateSiblings` in class `AbstractNodeWrapper`
      Parameters:
        `nodeTest` - a test that the returned siblings must satisfy
        `forwards` - true for following siblings, false for preceding siblings
      Returns:
        an iterator over the sibling nodes, in axis order.

    - #### iterateDescendants

          protected AxisIterator iterateDescendants​(java.util.function.Predicate<? super NodeInfo> nodeTest,
                                                    boolean includeSelf)

      Description copied from class: `AbstractNodeWrapper`
      Return an iterator over the descendants of this node. This method is only called after checking that the node is an element or document node.
      Overrides:
        `iterateDescendants` in class `AbstractNodeWrapper`
      Parameters:
        `nodeTest` - a test that the returned descendants must satisfy
        `includeSelf` - true if this node is to be included in the result
      Returns:
        an iterator over the sibling nodes, in axis order.

    - #### getRoot

          public NodeInfo getRoot()

      Get the root node of the tree containing this node
      Specified by:
        `getRoot` in interface `NodeInfo`
      Overrides:
        `getRoot` in class `AbstractNodeWrapper`
      Returns:
        the NodeInfo representing the top-level ancestor of this node. This will not necessarily be a document node

    - #### hasChildNodes

          public boolean hasChildNodes()

      Determine whether the node has any children.

      Note: the result is equivalent to `getEnumeration(Axis.CHILD, AnyNodeTest.getInstance()).hasNext()`

      Specified by:
        `hasChildNodes` in interface `NodeInfo`
      Overrides:
        `hasChildNodes` in class `AbstractNodeWrapper`
      Returns:
        True if the node has one or more children

    - #### generateId

          public void generateId​(FastStringBuffer buffer)

      Get a character string that uniquely identifies this node. Note: a.isSameNode(b) if and only if generateId(a)==generateId(b)
      Specified by:
        `generateId` in interface `NodeInfo`
      Parameters:
        `buffer` - a buffer to contain a string that uniquely identifies this node, across all documents

    - #### getDeclaredNamespaces

          public NamespaceBinding[] getDeclaredNamespaces​(NamespaceBinding[] buffer)

      Get all namespace undeclarations and undeclarations defined on this element.
      Specified by:
        `getDeclaredNamespaces` in interface `NodeInfo`
      Overrides:
        `getDeclaredNamespaces` in class `AbstractNodeWrapper`
      Parameters:
        `buffer` - If this is non-null, and the result array fits in this buffer, then the result may overwrite the contents of this array, to avoid the cost of allocating a new array on the heap.
      Returns:
        An array of integers representing the namespace declarations and undeclarations present on this element. For a node other than an element, return null. Otherwise, the returned array is a sequence of namespace codes, whose meaning may be interpreted by reference to the name pool. The top half word of each namespace code represents the prefix, the bottom half represents the URI. If the bottom half is zero, then this is a namespace undeclaration rather than a declaration. The XML namespace is never included in the list. If the supplied array is larger than required, then the first unused entry will be set to -1.

        For a node other than an element, the method returns null.